<?php
// $Id: uc_ccavenue.pages.inc,v 1.1.2.1 2009/09/09 13:00:04 zyxware Exp $

/**
 * @file
 * CCAvenue administration menu items.
 */

// Process Postbacks from uc_ccavenue.
function uc_ccavenue_redirect($order_id = 0) {
  global $conf;
  
  watchdog('uc_ccavenue', 'Receiving CCAvenue at URL for order @order_id. <pre>@debug</pre>',
    array('@order_id' => $order_id, '@debug' => variable_get('uc_ccavenue_debug', FALSE) ? print_r($_POST, TRUE) : ''));

  $WorkingKey = variable_get('uc_ccavenue_working_key', '') ; 
  $Merchant_Id= $_REQUEST['Merchant_Id'];
  $Amount= $_REQUEST['Amount'];
  $Order_Id= $_REQUEST['Order_Id'];
  $Merchant_Param= $_REQUEST['Merchant_Param'];
  $Checksum= $_REQUEST['Checksum'];
  $AuthDesc=$_REQUEST['AuthDesc'];
    
  $ChecksumValidate = verifyChecksum($Merchant_Id, $Order_Id , $Amount,$AuthDesc,$Checksum,$WorkingKey);
//  $ChecksumValidate = verifyChecksum($Merchant_Id, $Order_Id , $Amount,url('uc_ccavenue/ccavenue_redirect/'. $Order_Id, array('absolute' => TRUE)),$Checksum,$WorkingKey);

  //Validate if the order was correctly done
  $order = uc_order_load($Order_Id);

  if ($order == FALSE) {
    watchdog('uc_ccavenue', 'Return attempted for non-existent order.', array(), WATCHDOG_ERROR);
    return;
  }

  //Validate Checksum
  if ($ChecksumValidate != "true") {
    watchdog('uc_ccavenue', 'Checksum validation error for @order_id', array('@order_id' => $order_id), WATCHDOG_ERROR);
    return;
  }
  
  //Validate Duplicate Entries
  if ($ChecksumValidate == "true") {
    $duplicate = db_result(db_query("SELECT COUNT(*) FROM {uc_ccavenue} WHERE checksum = '%s' AND status <> 'Pending'", $Checksum));
    if ($duplicate > 0) {
      watchdog('uc_ccavenue', 'Transaction has been processed before.', array(), WATCHDOG_NOTICE);
      return;
    }
  }
  
  $payment_status = "";
  if ($AuthDesc=="Y" || $AuthDesc=="B") {
    $payment_status = "Completed";
  }
  else if ($AuthDesc=="N") {
    $payment_status = "Declined";
  }
  
  $receiver_email = uc_store_email_from();
  
  db_query("INSERT INTO {uc_ccavenue} (order_id, merchant_id, checksum, amount, status, receiver_email, payer_email, authdesc, received) VALUES (%d, '%s', '%s', '%s', '%s', '%s', '%s', '%s', %d)",
    $order_id, $Merchant_Id, $Checksum, $Amount, $payment_status, $receiver_email, $order->primary_email, $AuthDesc, time());

  $context = array(
    'revision' => 'formatted-original',
    'location' => 'ccavenue',
  );
  $options = array(
    'sign' => FALSE,
  );

  if($ChecksumValidate=="true" && $AuthDesc=="Y")
  {
    //echo "<br>Thank you for shopping with us. Your credit card has been charged and your transaction is successful. We will be shipping your order to you soon.";
    
    //Here you need to put in the routines for a successful 
    //transaction such as sending an email to customer,
    //setting database status, informing logistics etc etc
    
    $comment = t('CCAvenue transaction checksum: @checksum', array('@checksum' => $Checksum));
    uc_payment_enter($Order_Id, 'ccavenue', $Amount, $order->uid, NULL, $comment);
    uc_cart_complete_sale($order);
    uc_order_comment_save($Order_Id, 0, t('Payment of @amount @currency submitted through CCAvenue.', array('@amount' => uc_price($Amount, $context, $options), '@currency' => 'INR')), 'order', 'payment_received');
    uc_ccavenue_complete ($Order_Id);
  }
  else if($ChecksumValidate=="true" && $AuthDesc=="B")
  {
    //echo "<br>Thank you for shopping with us.We will keep you posted regarding the status of your order through e-mail";
    
    //Here you need to put in the routines/e-mail for a  "Batch Processing" order
    //This is only if payment for this transaction has been made by an American Express Card
    //since American Express authorisation status is available only after 5-6 hours by mail from ccavenue and at the "View Pending Orders"
    
    $comment = t('CCAvenue transaction checksum vis Amex CC: @checksum', array('@checksum' => $Checksum));
    uc_payment_enter($Order_Id, 'ccavenue', $Amount, $order->uid, NULL, $comment);
    uc_cart_complete_sale($order);
    uc_order_comment_save($Order_Id, 0, t('Payment of @amount @currency submitted through CCAvenue via Amex CC.', array('@amount' => uc_price($Amount, $context, $options), '@currency' => 'INR')), 'order', 'payment_received');
    uc_ccavenue_complete ($Order_Id);
  }
  else if($ChecksumValidate=="true" && $AuthDesc=="N")
  {
    //echo "<br>Thank you for shopping with us.However,the transaction has been declined.";
    
    //Here you need to put in the routines for a failed
    //transaction such as sending an email to customer
    //setting database status etc etc
    
    uc_order_comment_save($Order_Id, 0, t("The customer's attempted payment failed."), 'admin');
    uc_ccavenue_cancel ();
  }
  else
  {
    //echo "<br>Security Error. Illegal access detected";
    
    //Here you need to simply ignore this and dont need
    //to perform any operation in this condition
    
    uc_order_comment_save($Order_Id, 0, t('Security Error. Illegal access detected'), 'admin');
    uc_ccavenue_cancel ();
  }
}

// Handles a complete CCAvenue Payment sale.
function uc_ccavenue_complete($order_id = 0) {
  if (intval($_SESSION['cart_order']) != $order_id) {
    $_SESSION['cart_order'] = $order_id;
  }

  if (!($order = uc_order_load($order_id))) {
    drupal_goto('cart');
  }

  // This lets us know it's a legitimate access of the complete page.
  $_SESSION['do_complete'] = TRUE;

  drupal_goto('cart/checkout/complete');
}

// Handles a canceled CCAvenue Payment sale.
function uc_ccavenue_cancel() {
  unset($_SESSION['cart_order']);

  drupal_set_message(t('Your CCAvenue payment was cancelled. Please feel free to continue shopping or contact us for assistance.'));

  drupal_goto('cart');
}

